// Imagine++ project
// Project:  2048
// Author:   Pascal Monasse
// Date:     2019/10/25

#include "grille.h"
#include <Imagine/Graphics.h>
#include <string>
using namespace Imagine;

/// Q8. Test elementaire
void test_q8(Grille& g) {
    while(ajoute(g)) {
        clearWindow();
        dessine(g);
        click();
    }
}

/// Q16. Affichage du score
void score(const Grille& g) {
    std::string str = std::to_string(g.score);
    drawString(marge+z*n/2-str.size()*txt/2,
               marge/2+txt/2, str, RED, txt);
}

/// Affiche tout
void affichage(const Grille& g) {
    clearWindow();
    score(g);
    dessine(g);
}

int main() {
    openWindow(z*n+2*marge, z*n+2*marge, "2048"); // Q1

    Grille g;
    init(g);
    Grille prec = g;

    // test_q8(g);

    while(ajoute(g)) {
        dessine(g);
        int touche=getKey();
        while(touche==KEY_BACK) { // Q17. Undo
            g=prec;
            affichage(g);
            touche=getKey();
        }
        prec = g;
        decale(g, touche);
        affichage(g);
    }

    endGraphics();
    return 0;
}
